%
% script batch_2A.m: silent (no-graphics) execution of class_demo2A
%
        pars.GENERATE_P=12;  % =1: load 'Vowel.csv' (R mlbench), divide randomly in tst/trn (NOT recommended)
                             % =2: load 'vowel-context.data' (UCI repository, recommended)  
                             % =3: load 'vowel-train.csv', 'vowel-test.csv' (Renal assignment)
                             % =4: load 'wdbc.data (UCI repository, malignant & benign breast cancer)
                             % =9: load 'class_pat_gest.mat' (gesture data Polak/Hein)
                             % =10: load 'hk_gesture_all-norm*.mat' (KH_I gesture data K.Hein) 
                             % =11: load 'hk_gesture_set*-norm*.mat' (KH_II gesture data K.Hein) 
                             % =12: load 'iphonegesture-norm*.mat' (iphone data D. Bertram, K.Hein) 
        pars.tstdiv=1;       % =1: divide randomly in tst/trn even in case GENERATE_P=2 or 3
                             % =0: keep tst/trn from file in case GENERATE_P=2 or =3
        pars.tstfrac=0.20;   % which fraction of the patterns become test 
                             % patterns in case of random divide
        pars.tstvarseed=1;   % =1: vary seed, =0: always same seed (pars.seed, if def'd, 4 else), 
                             % for random number generator in case of random divide
        pars.ncopies=  0;    % if >0, add pars.ncopies noisy copies of the training data to
                             % the training data (this is for the case of few patterns per
                             % class, as compared to idim, to avoid overfitting)
        pars.ncsigma=0.8;    % the noise is pars.ncsigma*(standard deviation of input column),
                             % only relevant if pars.ncopies>0 (def. 0.8)
        pars.ncmetho=2;      % =1: each 'old' record from X in turn is the centroid for a new pattern
                             % =2: the centroid is the average of all records from the same class (*recommended*)
        pars.bootstrap=1;    % =1: parametric bootstrap by adding noisy data
                             % =2: only rotation
                             % =3: only shortened copies
                             % =4: shortened + rotated copies
        pars.MAX_ANGLE = 10; % limit the allowed angles to [-MAX_ANGLE,MAX_ANGLE], for boostrap=2
        pars.PERSON_ID=  -1; % -1: all persons, 121...130: only records of a specific person, 
                             % -121...-130: all records of persons <= |pars.PERSON_ID|
                             % (only for pars.GENERATE_P==10)

        opts.CL.aligned=1;      % =1: align the Gaussian classifiers with coordinate axes 
                             % (recommended, this is more robust if the data distribution deviates
                             % largely from multivariate Gaussian). 
                             % =0: don't align, can be more precise if data are Gaussian. 
        opts.dographics=0;   % =0: no plots, =1: some plots, >=2: more plots
        opts.dbg = 0;        % =1 for activating sfa_dbg in sfa2_step, else =0   
        opts.epsC = 0;       % cutoff eigenvalues of C smaller than epsC*lammax (def. 1e-7)   
        opts.gaussprj=1;     % 0/1: don't/do skip the PCA-preprocessing step for 'w/o SFA'
        opts.deg=2;          % 1/2: create SFA1 or SFA2 object (def. 2)
        opts.pp_range = 11;  % dims after preproc
                             % opts.*Filename controls, where the model is stored:
        opts.sFilename = 'datsave/ClassifierSFA.mat';
        opts.gFilename = 'datsave/ClassifierGauss.mat';
        opts.xFilename = 'datsave/ClassifierXGauss.mat'; 
            % If opts.xFilename is not def'd, then no Gauss classifier w/o SFA is stored.
            % The only consequence is that the output "w/o SFA" in class_demo2B.m will
            % be Inf ('not available').
            
res = class_demo2A(opts,pars)            