function [x,realclass,xtst,realc_tst,opts] = dataLoad(opts,pars)
%
% dataLoad is a common help routine for class_demo2.m and class_demo2A.m
%
    DBG=0;
    if pars.GENERATE_P==1 
        % read Vowel data (see R-Project, help on Vowel(mlbench), the CSV was written from R with
        %   library(mlbench)
        %   data(Vowel)
        %	V2 = cbind(Vowel, as.numeric(Vowel$Class))
        %   write.table(V2[,setdiff(names(V2,Class], file=Vowel.csv, quote=F, sep=";", dec=".", row.names=F, col.names=T)
        % ) 
        % *** CAUTION, NOT RECOMMENDED ***, since the R-dataset seems incomplete
        % (one input dim missing and not the right train/test division)
        % This branch resides only in here to reproduce the data error
        M=dlmread('datsave/Vowel.csv',';',1,0);
        x=M(:,2:10);
        realclass = M(:,11)';

        [x,xtst,realclass,realc_tst] = divide_rand(x,realclass,pars);
    end % pars.GENERATE_P==2

    if pars.GENERATE_P==2  || DBG==1
        % read Vowel data from
        % http://archive.ics.uci.edu/ml/datasets/Connectionist+Bench+%28Vow
        % el+Recognition+-+Deterding+Data%29  (UCI repository)
        M=dlmread('data/vowel-context.data');   
        % IMPORTANT: let DLMREAD infer the delimeter (one or more
        % whitespaces) from file, because only in this way, consecutive
        % whitespaces are treated as ONE delimiter
        %
        idx=find(M(:,1)==0);            % training index
        x=M(idx,4:13);
        realclass = M(idx,14)';    
        parallel_plot(x,realclass);
        idx=find(M(:,1)==1);            % test index
        xtst=M(idx,4:13);
        realc_tst = M(idx,14)';   
        
        if pars.tstdiv==1
            x = M(:,4:13);
            realclass = M(:,14)';
            [x,xtst,realclass,realc_tst] = divide_rand(x,realclass,pars);
        end

    end 
    
    if pars.GENERATE_P==3
        % read Vowel data from
        % http://www.inf.ed.ac.uk/teaching/courses/inf2b/coursework/cwk3.html 
        % (Steve Renals Homework Assignment) 
        % Same IO-records as in GENERATE_P==2, but different divide in train & test
        %
        Mtrn=csvread('data/vowel-train.csv');
        x=Mtrn(:,1:10);
        realclass = Mtrn(:,11)';    

        Mtst=csvread('data/vowel-test.csv');
        xtst=Mtst(:,1:10);
        realc_tst = Mtst(:,11)';
    
        if pars.tstdiv==1
            x = [Mtrn(:,1:10); Mtst(:,1:10)];
            realclass = [Mtrn(:,11); Mtst(:,11)]';
            [x,xtst,realclass,realc_tst] = divide_rand(x,realclass,pars);
        end
        %
    elseif pars.GENERATE_P==4
        % http://archive.ics.uci.edu/ml/datasets/Breast+Cancer+Wisconsin+(Diagnostic)
        % UCI repository, breast cancer, with replacement in column 2:
        %   M >> -1 (malignant)   and     B >> 2 (benign)
        M=csvread('data/wdbc.data');   
        c_col = 2;          % class column
        i_col = 3:32;       % input columns range
        x = M(:,i_col);
        [x,xtst,realclass,realc_tst] = divide_rand(x,M(:,c_col)',pars);
        parallel_plot(M(:,i_col),M(:,c_col));
        %
    elseif pars.GENERATE_P>=9 & pars.GENERATE_P<=12
        % read gesture data 
        % as they were generated by beginner.m (Marco Polak, Kristine Hein, pars.GENERATE_P=9)
        % or by load_*gesturedata.m in data/Gesture.d/* (pars.GENERATE_P>=10)
        %
        if (pars.GENERATE_P==9) 
            load('data/class_pat_gest.mat');
        elseif (pars.GENERATE_P==10)
            % read gesture data 
            % as they were generated by load_wiigesturedata.m (Kristine Hein, WK)
            % (see <fiwa_soma>/data/Gesture.d/WiiGestureData_KH_I/):
            path='data/';
            %path='../../../data/Gesture.d/WiiGestureData_KH_I/';
            %file = 'hk_gesture_all-norm0.mat';      % all 716 patterns, w/o  amplitude normalization (NOT recommended)
            file = 'hk_gesture_all-norm1.mat';      % all 716 patterns, with amplitude normalization
            %file = 'hk_gesture_p130.mat';           % only person 130
            fname = [path file];
            if ~exist(fname,'file'), fname=['../demo/data/' file];, end;
            load(fname); 
            % File fname contains the variables info_preproc, realclass, x
            % and optionally also the variable origin.
            disp(sprintf('Read %7d   gesture patterns from %s',size(info_preproc,1),fname));
            if ~exist('origin','var'), origin='KH_I/setUnknown-norm*'; end
        elseif (pars.GENERATE_P==11)
            % read gesture data 
            % as they were generated by load_wiigesturedata.m (Kristine Hein, WK)
            % (see <fiwa_soma>/data/Gesture.d/WiiGestureData_KH_II/):
            %path='data/';
            path='../../../data/Gesture.d/WiiGestureData_KH_II/';
            %file = 'hk_gesture_set1-norm0.mat';     % all 1730 patterns, w/o  amplitude normalization (NOT recommended)
            file = 'hk_gesture_set1-norm1.mat';      % all 1730 patterns, with amplitude normalization
            fname = [path file];
            if ~exist(fname,'file'), fname=['../demo/data/' file];, end;
            load(fname); 
            % File fname contains the variables info_preproc, realclass, x
            % and optionally also the variables gesture_meta and origin.
            disp(sprintf('Read %7d   gesture patterns from %s',size(info_preproc,1),fname));
            if ~exist('origin','var'), origin='KH_II/setUnknown-norm*'; end
        else % i.e. if pars.GENERATE_P==12
            % read iphone gesture data 
            % as they were generated load_iphonegesturedata.m (Daniel Bertram, Kristine Hein)
            % (see <fiwa_soma>/data/Gesture.d/iPhoneGestureData/)
            path='data/';
            %path='../../../data/Gesture.d/iPhoneGestureData/';
            file = 'iphonegesture-norm1.mat';     % all 892 patterns, with amplitude normalization 
            fname = [path file];
            if ~exist(fname,'file'), fname=['../demo/data/' file];, end;
            load(fname)
            % File fname contains the variables info_preproc, realclass, x
            % and optionally also the variable origin.
            disp(sprintf('Read %7d   gesture patterns from %s',size(info_preproc,1),fname));
            if ~exist('origin','var'), origin='iPhone: normUnknown'; end
        end    
        
        [info_preproc,realclass,x] = select_subset_person(pars,info_preproc,realclass,x);
        if numel(x)==0
            error('No training dataremain after select_subset_person()! Wrong pars.PERSON_ID?');
        end
        
        %opts.pp_range=11;
        if opts.dographics>0
            parallel_plot(x,realclass);
        end
        
        [x,xtst,realclass,realc_tst] = divide_rand(x,realclass,pars);
       
        % add pars.ncopies distorted copies, but only to the training data
        if pars.bootstrap==1
            % add noisy copies (Gaussian noise around class centroid)
            [realclass, x] = add_noisy_copies(realclass,x,pars);
        elseif pars.bootstrap >= 2
            % add random copies, randomly rotated and/or shorted
            if pars.ncopies > 0
                [realclass,x] = add_rotated_copies(realclass,x,pars);
            end
        end

    end % pars.GENERATE_P
    
    if DBG==1 && pars.GENERATE_P==3, dbg_P2_P3(M,Mtrn,Mtst); end
    
    opts.classes = unique(realclass);   % labels of the classes (we assume that each class appears
                                        % at least once in the training data)
    opts.nclass=numel(opts.classes);    % number of classes
    opts.gaussdim=opts.nclass-1;        % number of SFA-outputs used in Gauss classifier    
    opts.idim=size(x,2);                % number of input dimensions
    if ~isfield(opts,'pp_range')
        opts.pp_range=opts.idim;        % dims after preproc = number of input dims
    end
    if opts.pp_range>opts.idim
        opts.pp_range=opts.idim;        % dims after preproc may not be larger than number of input dims
    end
                                        
    % only needed for comparision with R and RF:
    % (see <fiwa_soma>\src\trunk\R-DM-Template\ClassifyTemplate\main_gesture.r)
    %write_gesture_csv(x,realclass,xtst,realc_tst);
    
end %dataLoad

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% some private helper functions
%
function [info_preproc,realclass,x] = select_subset_person(pars,info_preproc,realclass,x)        
    if pars.PERSON_ID~=-1
        if (pars.PERSON_ID<-1)
            idx = find(info_preproc(:,1)<=abs(pars.PERSON_ID));
            disp(['Selected subset of data for all persons with PERSON_ID<=' num2str(abs(pars.PERSON_ID));]);
        else
            idx = find(info_preproc(:,1)==pars.PERSON_ID);
            disp(['Selected subset of data for PERSON_ID=' num2str(pars.PERSON_ID);]);
        end
        %idx = find(info_preproc(:,1)==pars.PERSON_ID & realclass'~=1);
        realclass = realclass(idx);
        x = x(idx,:);
        info_preproc = info_preproc(idx,:);
    end
end

function dbg_P2_P3(M,Mtrn,Mtst)
    % check whether the records are the same with GENERATE_P==2 or ==3 
    % Answer: they are, but they have different ordering. If we order
    % each input column ascendingly, then each ordered column has
    % exactly the same contents.
    for k=0:9
        [tmp,idx1]=sort(M(:,4+k));
        M1 = M(idx1,:);
        M3 = [Mtrn(:,1:10); Mtst(:,1:10)];
        [tmp,idx3]=sort(M3(:,1+k));
        M3 = M3(idx3,:);
        Mdiff = abs(M1(:,4+k)-M3(:,1+k));
        fprintf('max(abs(M2-Mtrn)) = %g (col %d)\n',max(max(Mdiff)),k);
    end
end

function write_gesture_csv(x,realclass,xtst,realc_tst) 
    % write the matrix of exactly this test-training-division of
    % all data on file for comparision with R and RF (random
    % forest). First column: 1/0 for test/train record.
    tstidx = repmat(1,numel(realc_tst),1); 
    M = [tstidx realc_tst' xtst];  
    tstidx = repmat(0,numel(realclass),1);
    M = [M; tstidx realclass' x];
    path='data/';
    %path='C:\WUTemp\FH-MassenDaten\fiwa_soma\src\trunk\R-DM-Template\ClassifyTemplate\data\';
    dlmwrite([path 'gesture_pat.csv'],M,';');
    fprintf('Gesture data written onto gesture_pat.csv\n');
end 

