function parallel_plot(x,realclass,fontsize,tit)
    cl = unique(realclass);
    nclass = numel(cl);
    if nclass<6, f=14; else f=7; end;
    cmap = colormap(jet);
    colors=cmap(mod(f*(1:nclass),size(cmap,1)) +1,:); 
    
    figure(4); clf; set(gcf, 'Position', [89 77 866 638]);
    set(gca,'Box','on');
    if exist('fontsize'), set(gca, 'FontSize', fontsize); end;
    if exist('tit'), title(tit); end;
    hold on; 
    dim = size(x,2);
    for i=1:nclass
        ind = find(realclass==cl(i));
        %fprintf('Class %d has %d patterns\n',cl(i),numel(ind));
        for k=1:numel(ind)
            plot(1:dim,x(ind(k),:),'Color',colors(i,:),'LineStyle','-');
        end
    end     
    xlabel('input dimensions'); ylabel('data');
    %ylim([-500 500]);
end
