function hdl=gaussLoad(filename)
% gaussLoad: Load a GAUSS object.
%   HDL = gaussLoad(FILENAME) loads the GAUSS object saved in the file
%   FILENAME and assign to it the handle HDL. The file must have been
%   saved by gaussSave.
%
%   See also gaussSave
  
  global GAUSS_STRUCTS
  
  % init if first call
  if isempty(GAUSS_STRUCTS),
    GAUSS_STRUCTS=cell(3,1);
  end
    
  % find empty slot
  hdl=-1;
  for i=1:size(GAUSS_STRUCTS,1)
    if isempty(GAUSS_STRUCTS{i}),
      hdl=i;
      break;
    end
  end
  if hdl==-1, hdl=size(GAUSS_STRUCTS,1)+1; end

  load(filename);
  GAUSS_STRUCTS{hdl}=strct;
