function eta = etaval(x,T)
% ETAVAL Computes the eta value of a signal.
%   eta = ETAVAL(X, T) returns the eta value of the signal X in a
%   time interval T time units long.
%   The columns of X correspond to different input components.
%   X does NOT need to be normalized to zero mean and unit variance.
    eta = (T/(2*pi))*sqrt(mean(diff(x).^2))/sqrt(mean((x-mean(x)).^2));
end

