function opts = optsDefault()
%  Set defaults for struct opts, a struct with several parameter settings for SFA_CLASSIFY. 
%   
        opts.gaussprj=1;     % 1/0: do/don't skip the PCA-preprocessing step for 'w/o SFA'
        opts.deg=2;          % 1/2: create SFA1 or SFA2 object (def. 2)
        opts.pp_range = 11;  % dims after preproc
        opts.epsC = 0;       % cut off eigenvalues of C smaller than epsC*lammax (recommended: 0)   
        opts.CL.aligned=1;   % =1: align the Gaussian classifiers with coordinate axes 
                             % (recommended, this is more robust if the data distribution deviates
                             % largely from multivariate Gaussian). 
                             % =0: don't align, can be more precise if data are Gaussian. 
        opts.CL.algo='gauss';% either 'gauss' or 'nearneig'; 
        opts.CL.epsD=0.01;   % >0: regularize diagonal elements of covariance matrix in Gauss classifier
        opts.dographics=2;   % =0: no plots, =1: some plots, >=2: more plots
        opts.dbg = 0;        % =1 for activating sfa_dbg in sfa2_step, else =0   
        opts.verbose=2;
                             % opts.*Filename controls, where the model is stored (class_demo2A only):
        opts.sFilename = 'datsave/ClassifierSFA.mat';
        opts.gFilename = 'datsave/ClassifierGauss.mat';
        opts.xFilename = 'datsave/ClassifierXGauss.mat'; 
            % If opts.xFilename is not def'd, then no Gauss classifier w/o SFA is stored.
            % The only consequence is that the output "w/o SFA" in class_demo2B.m will
            % be Inf ('not available').

        % some more fields of struct opts will be set after loading the data (see dataLoad.m or dataLoadCV.m):
        %   opts.idim       % number of input dimensions
        %   opts.pp_range   % dims after preproc (may not be larger than opts.idim)
        %   opts.classes    % labels of the classes (we assume that each class appears
                            % at least once in the training data)
        %   opts.nclass     % number of classes
        %   opts.gaussdim   % number of SFA-outputs used in Gauss classifier 
end        
                                        
